---

default:
  tags:
    - oit-shared-buildah

stages:
  - build
  - deploy

variables:
  DOCKERFILE: ""
  IMAGE_LABELS: >
    --label org.opencontainers.image.vendor=$CI_SERVER_URL/$GITLAB_USER_LOGIN
    --label org.opencontainers.image.authors=$CI_SERVER_URL/$GITLAB_USER_LOGIN
    --label org.opencontainers.image.revision=$CI_COMMIT_SHA
    --label org.opencontainers.image.source=$CI_PROJECT_URL
    --label org.opencontainers.image.documentation=$CI_PROJECT_URL
    --label org.opencontainers.image.licenses=$CI_PROJECT_URL
    --label org.opencontainers.image.url=$CI_PROJECT_URL
    --label vcs-url=$CI_PROJECT_URL
    --label com.gitlab.ci.user=$CI_SERVER_URL/$GITLAB_USER_LOGIN
    --label com.gitlab.ci.email=$GITLAB_USER_EMAIL
    --label com.gitlab.ci.tagorbranch=$CI_COMMIT_REF_NAME
    --label com.gitlab.ci.pipelineurl=$CI_PIPELINE_URL
    --label com.gitlab.ci.commiturl=$CI_PROJECT_URL/commit/$CI_COMMIT_SHA
    --label com.gitlab.ci.cijoburl=$CI_JOB_URL
    --label com.gitlab.ci.mrurl=$CI_PROJECT_URL/-/merge_requests/$CI_MERGE_REQUEST_ID


buildah:build:
  variables:
    FULL_IMAGE_NAME: ${CI_REGISTRY_IMAGE}/${CI_PROJECT_NAME}:latest
    S2I_IMAGE: gitlab-registry.oit.duke.edu/oit-ssi-systems/openshift/openshift-builder-images/mkdocs-s2i:main
    DOCKERFILE: Dockerfile
  stage: build
  script:
    - set -euxo pipefail
    - export STORAGE_DRIVER=vfs
    - export REGISTRY_AUTH_FILE=${HOME}/auth.json
    - echo "${CI_REGISTRY_PASSWORD}" | buildah login -u "${CI_REGISTRY_USER}" --password-stdin ${CI_REGISTRY}
    - buildah bud ${IMAGE_LABELS} -f ${DOCKERFILE} -t ${FULL_IMAGE_NAME}
    - buildah push ${FULL_IMAGE_NAME}

deploy:
  tags:
    - oit-shared-unprivileged
  stage: deploy
  image: gitlab-registry.oit.duke.edu/duke_openshift_users/community-supported-resources/build-helper:ubuntu22
  script:
    - kubectl get pods
    - kubectl rollout restart deployment/okd-docs